{=======================================================================================================================

   " ".

       .

========================================================================================================================

  :

  08.03.2015 [*]    -.
             [+]   .
             [*]  .
  26.02.2015 [+]    .
  25.02.2015 [*]  DBNavigator  .
  22.02.2015 [*]   .
  11.03.2012 [+]   .
             [+]  ComboBox   .
  08.03.2012 [*] .
  28.02.2012 [*]      .
  24.02.2012 [*] .
  22.02.2012 [+]   .
  20.02.2012 [+] RefreshFind:   .
  19.02.2012 [*]          .
  14.02.2012 [+]  .
             [+]   .
             [+]    TBASEListDG.
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgBaseFind.pas,v 1.3 2015/03/11 13:34:26 tsk Exp $
=======================================================================================================================}
unit dgBaseFind;

interface

uses  Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, Buttons, ExtCtrls, Grids, DBGrids, DBCtrls, Db,
      DBGridEh, PropFilerEh, PropStorageEh, DBGridEhGrouping, GridsEh, Data.Win.ADODB, ToolCtrlsEh, DBGridEhToolCtrls,
      DynVarsEh, DBAxisGridsEh, Dialogs,
      // Comming:
      CommingADO;

type
  TBASEFindDG = class( TForm )
    grList: TDBGridEh;
    dsFind: TDataSource;
    btExit: TBitBtn;
    btBack: TBitBtn;
    edFind: TComboBox;
    taFind: TADODataSet;
    taFindID: TIntegerField;
    taFindName: TStringField;
    storFind: TPropStorageEh;
    btInsert: TBitBtn;
    procedure btBackClick(Sender: TObject);
    procedure edFindChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FVisual: Boolean;
    procedure SetVisual(const Value: Boolean);     { Private declarations }
  public      { Public declarations }
    FieldUpdate: TField;
    EditEpty: String;
    property Visual: Boolean read FVisual write SetVisual;
    procedure RefreshFind;
    constructor CreateFull(AOwner: TComponent; Field: TField = nil );
  end;

implementation

uses dmCommingData;

{$R *.DFM}
//======================================================================================================================
{ TBASEFindDG }
//======================================================================================================================
constructor TBASEFindDG.CreateFull( AOwner: TComponent; Field: TField );
begin
  inherited Create( AOwner );
  FieldUpdate := Field;
end;
//======================================================================================================================
procedure TBASEFindDG.FormCreate(Sender: TObject);
begin
  EditEpty := edFind.Text;
  edFind.Hint := EditEpty;
end;
//======================================================================================================================
procedure TBASEFindDG.FormShow(Sender: TObject);
begin
  edFind.SetFocus;
  edFind.ItemIndex := -1;
  edFind.SelStart := 0;
  edFindChange( Sender );
end;
//======================================================================================================================
procedure TBASEFindDG.SetVisual(const Value: Boolean);
begin
  if FVisual <> Value then begin
    if FVisual then begin
//      Screen.Cursor := crDefault;
      FieldUpdate.DataSet.EnableControls;
    end else begin
      FieldUpdate.DataSet.DisableControls;
//      Screen.Cursor := crHourGlass;
    end;
  end;
end;
//======================================================================================================================
procedure TBASEFindDG.edFindChange( Sender: TObject );
  var p: Integer;
      s: String;
begin
  if csLoading in ComponentState then Exit;
  if (edFind.Text = EmptyStr ) or (edFind.Text = EditEpty ) then begin
    edFind.Font.Color := clGrayText;
    btBack.Enabled := False;
    edFind.Text := EditEpty;
    RefreshFind;
  end else begin
    p := Pos( EditEpty, edFind.Text);
    if p > 0 then begin
      s := edFind.Text;
      Delete( s, p, Length( EditEpty ));
      edFind.Text := s;
      edFind.SelStart := length( s );
    end;
    edFind.Font.Color := clWindowText;
    RefreshFind;
    btBack.Enabled := ( taFind.RecordCount > 0 );
  end;
end;
//======================================================================================================================
procedure TBASEFindDG.RefreshFind;
begin
  RequeryParameters( taFind, [ Trim( edFind.Text )]);
end;
//======================================================================================================================
procedure TBASEFindDG.btBackClick(Sender: TObject);
begin
  if edFind.Items.IndexOf( Trim( edFind.Text )) < 0 then edFind.Items.Add( Trim( edFind.Text ));
  while edFind.Items.Count > edFind.DropDownCount do edFind.Items.Delete( 0 );
  if FieldUpdate <> nil then SetField( FieldUpdate, taFindID.Value);
end;
//======================================================================================================================
end.
