{=======================================================================================================================

   "".

     ,  .

========================================================================================================================

  :

  12.03.2015 [+] Component:  .
  06.03.2015 [*]    .
  04.03.2015 [+] Model.Default( KindType ) = 'H'.
  03.03.2015 [+] Kind.Default( KindType ) = 'D'.
  24.02.2015 [+] Department, Workplace, Device. taDevice, taWorkplace.
  22.02.2015 [+] taKind.
  21.02.2015 [+] taModel.
  20.02.2015 [+] Component. Model. Kind. KindType. Document, DocumentPosition. taComponent.
             [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dmChainData.pas,v 1.3 2015/03/11 23:05:51 tsk Exp $
=======================================================================================================================}
unit dmChainData;

interface

uses  System.SysUtils, System.Classes, PropFilerEh, PropStorageEh, Data.DB, Data.Win.ADODB,
      // Comming;
      CommingADO;

type
  TdmChain = class(TDataModule)
    taComponent: TADODataSet;
    stMain: TPropStorageEh;
    taComponentIDComponent: TIntegerField;
    taComponentIDModel: TIntegerField;
    taComponentIDKind: TSmallintField;
    taComponentIDType: TStringField;
    taComponentIDDocument: TIntegerField;
    taComponentNBPosition: TSmallintField;
    taComponentIDShipper: TIntegerField;
    taComponentIDShipperTM: TSmallintField;
    taComponentIDProducer: TIntegerField;
    taComponentIDProducerTM: TSmallintField;
    taModel: TADODataSet;
    taModelIDModel: TIntegerField;
    taModelIDKind: TSmallintField;
    taModelIDType: TStringField;
    taModelIDProducer: TIntegerField;
    taModelIDProducerTM: TSmallintField;
    taKind: TADODataSet;
    taKindIDKind: TSmallintField;
    taKindIDType: TStringField;
    taDevice: TADODataSet;
    taDeviceIDDevice: TIntegerField;
    taDeviceIDKind: TSmallintField;
    taDeviceIDWorkplace: TIntegerField;
    taDeviceIDDepartment: TIntegerField;
    taWorkplace: TADODataSet;
    taWorkplaceIDWorkplace: TIntegerField;
    taWorkplaceIDDepartment: TIntegerField;
    taComponentIDDevice: TIntegerField;
    procedure stMainAfterLoadProps(Sender: TObject);
  private  { Private declarations }
    FComponent: Integer;
    FModel: Integer;
    FKind: Integer;
    FKindType: String;
    FDocument: Integer;
    FDocumentPosition: Integer;
    FProducer: Integer;
    FProducerTM: Integer;
    FDepartment: Integer;
    FWorkplace: Integer;
    FDevice: Integer;
    procedure SetComponent(const Value: Integer);
    procedure SetModel(const Value: Integer);
    procedure SetKind(const Value: Integer);
    procedure SetKindType(const Value: String);
    procedure SetDocument(const Value: Integer);
    procedure SetDocumentPosition(const Value: Integer);
    procedure SetProducer(const Value: Integer);
    procedure SetProducerTM(const Value: Integer);
    procedure SetDepartment(const Value: Integer);
    procedure SetWorkplace(const Value: Integer);
    procedure SetDevice(const Value: Integer);
  public  { Public declarations }
    property Component: Integer read FComponent write SetComponent;
    property Model: Integer read FModel write SetModel;
    property Kind: Integer read FKind write SetKind;
    property KindType: String read FKindType write SetKindType;
    property Producer: Integer read FProducer write SetProducer;
    property ProducerTM: Integer read FProducerTM write SetProducerTM;
    property Document: Integer read FDocument write SetDocument;
    property DocumentPosition: Integer read FDocumentPosition write SetDocumentPosition;
    property Department: Integer read FDepartment write SetDepartment;
    property Workplace: Integer read FWorkplace write SetWorkplace;
    property Device: Integer read FDevice write SetDevice;
  end;

var dmChain: TdmChain;

implementation
{%CLASSGROUP 'Vcl.Controls.TControl'}
{$R *.dfm}
//======================================================================================================================
{ TChainDM }
//======================================================================================================================
procedure TdmChain.stMainAfterLoadProps(Sender: TObject);
begin
  Component := taComponent.Tag;
end;
//======================================================================================================================
procedure TdmChain.SetComponent( const Value: Integer );
begin
  FComponent := Value;
  taComponent.Tag := FComponent;
  RequeryParameters( taComponent, [ FComponent ]);
  FDevice           := taComponentIDDevice.Value;
  FModel            := taComponentIDModel.Value;
  FKind             := taComponentIDKind.Value;
  FKindType         := taComponentIDType.AsString;
  FProducer         := taComponentIDProducer.Value;
  FProducerTM       := taComponentIDProducerTM.Value;
  FDocument         := taComponentIDDocument.Value;
  FDocumentPosition := taComponentNBPosition.Value;
  taComponent.Close;
end;
//======================================================================================================================
procedure TdmChain.SetModel( const Value: Integer );
begin
  FModel := Value;
  taModel.Tag := FModel;
  RequeryParameters( taModel, [ FModel ]);
  FModel      := taModelIDModel.Value;
  FKind       := taModelIDKind.Value;
  FKindType   := taModelIDType.AsString;
  FProducer   := taModelIDProducer.Value;
  FProducerTM := taModelIDProducerTM.Value;
  taModel.Close;
end;
//======================================================================================================================
procedure TdmChain.SetKind( const Value: Integer );
begin
  FKind := Value;
  taKind.Tag := FKind;
  RequeryParameters( taKind, [ FKind ]);
  FKind := taKindIDKind.Value;
  if not taKindIDType.IsNull
    then FKindType := taKindIDType.AsString
    else FKindType := 'D';
  taModel.Close;
end;
//======================================================================================================================
procedure TdmChain.SetKindType(const Value: String);
begin
  FKindType := Value;
end;
//======================================================================================================================
procedure TdmChain.SetProducer(const Value: Integer);
begin
  FProducer := Value;
end;
//======================================================================================================================
procedure TdmChain.SetProducerTM(const Value: Integer);
begin
  FProducerTM := Value;
end;
//======================================================================================================================
procedure TdmChain.SetDocument(const Value: Integer);
begin
  FDocument := Value;
end;
//======================================================================================================================
procedure TdmChain.SetDocumentPosition(const Value: Integer);
begin
  FDocumentPosition := Value;
end;
//======================================================================================================================
procedure TdmChain.SetDepartment(const Value: Integer);
begin
  FDepartment := Value;
end;
//======================================================================================================================
procedure TdmChain.SetWorkplace(const Value: Integer);
begin
  FWorkplace := Value;
  taWorkplace.Tag := FWorkplace;
  RequeryParameters( taWorkplace, [ FWorkplace ]);
  FDepartment := taWorkplaceIDDepartment.Value;
  taWorkplace.Close;
end;
//======================================================================================================================
procedure TdmChain.SetDevice(const Value: Integer);
begin
  FDevice := Value;
  taDevice.Tag := FDevice;
  RequeryParameters( taDevice, [ FDevice ]);
  FKind       := taDeviceIDKind.Value;
  FWorkplace  := taDeviceIDWorkplace.Value;
  FDepartment := taDeviceIDDepartment.Value;
  taDevice.Close;
end;
//======================================================================================================================
end.
