/*=====================================================================================================================

   " ".

    .

=======================================================================================================================

  :

  08.03.2015 [+] FindKind:  .
             [*] FindModel:  .
  25.02.2015 [*] FindBase:   (   ).
  24.03.2012 [*] FindDevice:  ViewDevicePowerName, ViewWorkplacePowerName.
  28.02.2012 [+] FindModel:  .
  22.02.2012 [+] FindDevice:  .
  15.02.2012 [+] FindWorkplace:   .
             [*] FindDepartment:   .
  14.02.2012 [+] FindDepartment:  .
             [+] FindBase:    .
             [+]  .
  09.10.1997 [!]  .

=======================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scFind.sql,v 1.2 2015/03/08 09:03:46 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropProcedure 'FindBase'
EXECUTE CheckDropProcedure 'FindDepartment'
EXECUTE CheckDropProcedure 'FindWorkplace'
EXECUTE CheckDropProcedure 'FindDevice'
EXECUTE CheckDropProcedure 'FindModel'
EXECUTE CheckDropProcedure 'FindKind'
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindBase
AS
  SELECT DISTINCT IdDepartment AS ID, 
                  DprtName AS Name 
    FROM Department 
    ORDER BY DprtName
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindDepartment @NM VARCHAR(150)
AS
  SELECT DISTINCT IdDepartment AS ID, 
                  DprtName AS Name  
    FROM Department
    WHERE ( DprtName + ISNULL( Synonym, '' ) LIKE '%' + @NM + '%')
    ORDER BY DprtName
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindWorkplace @NM VARCHAR(150)
AS
  DECLARE @CP VARCHAR(150)
  IF LEN(@NM) < 3 SET @CP = @NM + '%' ELSE SET @CP = '%' + @NM + '%'
  SELECT Workplace.IdWorkplace AS ID, 
         Workplace.WrkpName + ' (' + Department.DprtName + ')' AS Name,
         Workplace.WrkpIdDepartment AS Department
    FROM Workplace 
      LEFT OUTER JOIN [User] ON Workplace.[User] = [User].ID
      INNER JOIN Department ON Workplace.WrkpIdDepartment = Department.IdDepartment
    WHERE (Workplace.WrkpName + ISNULL('  ' + Workplace.Synonym, '') + ISNULL('  ' + Workplace.Phone, '') 
             + ISNULL('  ' + [User].Login, '') + ISNULL('  ' + [User].Name, '') LIKE @CP )
    ORDER BY Name
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindDevice @NM VARCHAR(150)
AS
  DECLARE @CP VARCHAR(150)
  IF LEN(@NM) < 3 SET @CP = @NM + '%' ELSE SET @CP = '%' + @NM + '%'
  SELECT ViewDevicePowerName.ID, 
         ViewDevicePowerName.NameFind + ' [' + ViewWorkplacePowerName.NameUserDepartment + ']' AS Name
    FROM ViewDevicePowerName 
      INNER JOIN ViewWorkplacePowerName ON ViewDevicePowerName.High = ViewWorkplacePowerName.ID
    WHERE (ViewDevicePowerName.NameNumber + ViewWorkplacePowerName.NameFind LIKE @CP)
    ORDER BY ViewDevicePowerName.Sorting, ViewWorkplacePowerName.[Order]
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindModel @NM VARCHAR(150)
AS
  DECLARE @CP VARCHAR(150)
  IF LEN(@NM) < 3 SET @CP = @NM + '%' ELSE SET @CP = '%' + @NM + '%'
  SELECT Model.IdModel AS ID, 
         Model.ModlKind AS Kind, 
         Model.DisplayName + ISNULL(' (' + Client.ClntNameFull + ')', '') AS Name,
         KindType
    FROM Model 
      INNER JOIN Client ON Model.ModlIdProducer = Client.IdClient
      INNER JOIN Kind ON Model.ModlKind = Kind.IdKind
    WHERE (Model.DisplayName + ISNULL(' ' + Client.ClntNameFull, '') + ISNULL(' ' + Client.ClntNameShort, '') LIKE @CP)
    ORDER BY Name
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindKind @NM VARCHAR(150)
AS
  SELECT IdKind AS ID, 
         KindType, 
         ISNULL(ShortName + ': ', '') + KindName AS Name
    FROM Kind
    WHERE (ISNULL(ShortName + ' ', '') + KindName LIKE '%' + @NM + '%')
    ORDER BY Name
--
GO
--=====================================================================================================================
-- 
--
--EXECUTE FindBase
--EXECUTE FindDepartment 't'
--EXECUTE FindWorkplace ''
--EXECUTE FindDevice 'tsk'
--EXECUTE FindModel 'E10'
EXECUTE FindKind 'pr'

