/*=====================================================================================================================

   " ".

      . .

=======================================================================================================================

  :

  09.04.2012 [*] ReportWorkplaceDetail:    .
  24.02.2012 [*] .
  19.02.2012 [+] ReportWorkplaceDetail:      .
             [+] ReportWorkplaceTitle:     .
             [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scWorkplaceReport.sql,v 1.1 2013/06/07 13:41:29 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--USE [ComputerWare.test]
--
EXECUTE CheckDropProcedure 'ReportWorkplaceTitle'
EXECUTE CheckDropProcedure 'ReportWorkplaceDetail'
--
GO
--=====================================================================================================================
CREATE PROCEDURE ReportWorkplaceTitle @WP INT
AS
  DECLARE @NM VARCHAR(500), @DN VARCHAR(1000), @DP INT
  SELECT @NM = Workplace.WrkpName + ISNULL(' [' + Workplace.Phone + ']', '') + ISNULL(' (' + [User].Name + ')', ''),
         @DP = Workplace.WrkpIdDepartment 
    FROM Workplace LEFT OUTER JOIN [User] ON Workplace.[User] = [User].ID
    WHERE (Workplace.IdWorkplace = @WP)
  --
  SELECT @DP = DprtIdHigher, @DN = DprtName FROM Department WHERE (IdDepartment = @DP)
  WHILE @DP <> 0 
    SELECT @DP = DprtIdHigher, @DN = @DN  + '/'+ DprtName FROM Department WHERE (IdDepartment = @DP)
--
  SELECT @DN AS Department, @NM AS Name
--
GO
--=====================================================================================================================
CREATE PROCEDURE ReportWorkplaceDetail @WP INT
AS
  SELECT ViewDevicePowerName.NameNumber AS DevName, 
         Kind.KindName, 
         Model.ModlName + ISNULL(': ' + Model.ModlParametersValue, '') + ISNULL(' (' + Model.ModlNote + ')', '') AS ModName, 
         CompleteSet.DisplayNumber, 
         ViewDocumentPowerName.NameFirm AS DocName
    FROM Workplace 
      INNER JOIN ViewDevicePowerName ON Workplace.IdWorkplace = ViewDevicePowerName.High 
      INNER JOIN CompleteSet ON ViewDevicePowerName.ID = CompleteSet.CmplIdDevice 
      INNER JOIN Model ON CompleteSet.CmplIdModel = Model.IdModel 
      INNER JOIN Kind ON Model.ModlKind = Kind.IdKind 
      LEFT OUTER JOIN ViewDocumentPowerName ON CompleteSet.DocumentId = ViewDocumentPowerName.ID
    WHERE (Workplace.IdWorkplace = @WP)
    ORDER BY ViewDevicePowerName.Sorting, Kind.KindOrder
--
GO
--=====================================================================================================================
-- 
--
-- 346 - 
-- 343 - .    ( ..)
--
--EXECUTE ReportWorkplaceTitle 343
EXECUTE ReportWorkplaceDetail 343

