{=======================================================================================================================

   " ".

        .

========================================================================================================================

  :

  03.07.2014 [+]    .
  02.07.2014 [+]    .
  28.06.2014 [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972014 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgComputerPing.pas,v 1.6 2015/03/08 05:02:40 tsk Exp $
=======================================================================================================================}
unit dgComputerPing;

interface

uses  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, Vcl.Controls,
      Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, DBGridEh, Vcl.Mask, Vcl.Buttons, Data.DB,
      Data.Win.ADODB, Vcl.ComCtrls, IdBaseComponent, IdComponent, IdRawBase, IdRawClient, IdIcmpClient, WinSock,
      // Comming:
      CommingADO, PropFilerEh, PropStorageEh;

type
  TComputerPingDG = class(TForm)
    mmLog: TMemo;
    btRun: TBitBtn;
    btExit: TBitBtn;
    pbPing: TProgressBar;
    taComputer: TADODataSet;
    taComputerIdDevice: TAutoIncField;
    taComputerDomain: TStringField;
    taComputerOnLine: TBooleanField;
    inPing: TIdIcmpClient;
    taComputerPreventionNeed: TBooleanField;
    cbLog: TCheckBox;
    stEdit: TPropStorageEh;
    procedure btRunClick(Sender: TObject);
    procedure inPingReply(ASender: TComponent; const AReplyStatus: TReplyStatus);
  private   { Private declarations }
    procedure AddLastLine( Add: String);
  public    { Public declarations }
    procedure Run;
  end;

var ComputerPingDG: TComputerPingDG;

implementation

{$R *.dfm}

uses dmCommingData;

//======================================================================================================================
{ TComputerPingDG }
//======================================================================================================================
procedure TComputerPingDG.Run;
begin
  if ComputerPingDG = nil then Application.CreateForm( TComputerPingDG, ComputerPingDG );
  ComputerPingDG.ShowModal;
end;
//======================================================================================================================
procedure TComputerPingDG.AddLastLine( Add: String );
begin
  mmLog.Lines[mmLog.Lines.Count - 1] := mmLog.Lines[mmLog.Lines.Count - 1] + ': ' + Add + '.';
end;
//======================================================================================================================
procedure TComputerPingDG.btRunClick(Sender: TObject);
  var shost, Log: String;
begin
  btRun.Enabled := False;
  btExit.Enabled := False;
  taComputer.Open;
  pbPing.Position := 0;
  mmLog.Clear;
  mmLog.Lines.Add( ' : ' + IntToStr( taComputer.RecordCount ) + '.');
  pbPing.Max := taComputer.RecordCount;
  while not taComputer.Eof do begin
    shost := taComputerDomain.AsString;
    mmLog.Lines.Add( shost );
    inPing.Host := shost;
    try
      inPing.Ping( shost );
    except begin
      taComputer.Edit;
      taComputerOnLine.Value := False;
//      taComputerPreventionNeed.Value := False;
      taComputer.Post;
      AddLastLine( 'not host' )
    end end;
    pbPing.Position := pbPing.Position + 1;
    Application.ProcessMessages;
    taComputer.Next;
  end;
  taComputer.Close;
  Log := ExtractFilePath( Application.ExeName ) + 'SC[' + FormatDateTime( 'YYYY.MM.DD HH=NN', Now()) + '].log';
  if cbLog.Checked then begin
    mmLog.Lines.SaveToFile( Log );
    mmLog.Lines.Add( '   ' + Log + '.')
  end;
  btRun.Enabled := True;
  btExit.Enabled := True;
end;
//======================================================================================================================
procedure TComputerPingDG.inPingReply(ASender: TComponent; const AReplyStatus: TReplyStatus);
begin
  taComputer.Edit;
  if ( AReplyStatus.ReplyStatusType = rsEcho )
    then taComputerOnLine.Value := True
    else taComputerOnLine.Value := False;
  taComputer.Post;
  if taComputerOnLine.Value
    then AddLastLine( 'on-line' )
    else AddLastLine( 'off-line' )
end;
//======================================================================================================================
end.
