/*=====================================================================================================================

   " ".

      .

=======================================================================================================================

  :

  05.05.2015 [+] ReportUserInfo: SKYPE.
  27.05.2014 [+] ReportMailBox:    .
  16.04.2014 [+] ReportUserInfo:   .
  15.04.2014 [!]        ( scCommingReport.sql).
  17.03.2012 [+] ReportMailBox:    .
  05.03.2012 [+] ReportUser:  .
  17.02.2012 [+]  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972014 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scUserReport.sql,v 1.5 2015/05/05 08:49:08 tsk Exp $
=====================================================================================================================*/
USE ComputerWare
--
EXECUTE CheckDropProcedure  'ReportUser'
EXECUTE CheckDropProcedure  'ReportUserInfo'
EXECUTE CheckDropProcedure  'ReportMailBox'
--
GO
--=====================================================================================================================
CREATE PROCEDURE ReportUser
AS
  SELECT [User].Login       AS [], 
         [User].Name        AS [  ], 
         [User].Pass        AS [], 
         DeviceUnit.Domain  AS [], 
         Workplace.Phone    AS [.]
    FROM DeviceUnit 
      INNER JOIN UseComputer ON DeviceUnit.IdDevice = UseComputer.Computer 
      INNER JOIN Workplace ON DeviceUnit.DevcIdWorkplace = Workplace.IdWorkplace 
      RIGHT OUTER JOIN [User] ON UseComputer.[User] = [User].ID
   ORDER BY [User].Login
--
GO
--=====================================================================================================================
CREATE PROCEDURE ReportUserInfo @ID INT
AS
  SELECT NameFull, 0 AS Line, CAST('' AS VARCHAR(50)) AS Parameter, CAST('' AS VARCHAR(50)) AS Value
    FROM [User] WHERE (ID = @ID)
  --
  UNION
  --
  SELECT NameFull, 1, ' ()', Domain FROM [User] WHERE (ID = @ID) AND (NOT (Domain IS NULL))
  --
  UNION
  --
  SELECT NameFull, 2, ' ', Login FROM [User] WHERE (ID = @ID) AND (NOT (Login IS NULL))
  --
  UNION
  --
  SELECT NameFull, 3, '', Pass FROM [User] WHERE (ID = @ID) AND (NOT (Pass IS NULL))
  --
  UNION
  --
  SELECT NameFull, 4, ' ', EMail FROM [User] WHERE (ID = @ID) AND (NOT (EMail IS NULL))
  --
  UNION
  --
  SELECT NameFull, 5, ' ', MailPass FROM [User] WHERE (ID = @ID) AND (NOT (MailPass IS NULL))
  --
  UNION
  --
  SELECT NameFull, 6, 'SKYPE, ', SkypeLogin FROM [User] WHERE (ID = @ID) AND (NOT (SkypeLogin IS NULL))
  --
  UNION
  --
  SELECT NameFull, 7, 'SKYPE, ', SkypePass FROM [User] WHERE (ID = @ID) AND (NOT (SkypePass IS NULL))
  --
  UNION
  --
  SELECT [User].NameFull, 8, ' ', Workplace.WrkpName + ISNULL(', : ' + Workplace.Phone, '')
    FROM Workplace INNER JOIN [User] ON Workplace.[User] = [User].ID WHERE (Workplace.[User] = @ID)  
  --
  UNION
  --
  SELECT [User].NameFull, 9, '', DeviceUnit.Domain
    FROM UseComputer 
      INNER JOIN [User] ON UseComputer.[User] = [User].ID 
      INNER JOIN DeviceUnit ON UseComputer.Computer = DeviceUnit.IdDevice
    WHERE (UseComputer.[User] = @ID) AND (NOT (DeviceUnit.Domain IS NULL))  
  --
  ORDER BY 2
--
GO
--=====================================================================================================================
CREATE PROCEDURE ReportMailBox
AS
  SELECT EMail + ISNULL( ' / ' + EMailGroup, '') AS [e-mail], 
         MailPass AS pass, 
         Name
    FROM [User]
    WHERE (NOT (EMail IS NULL))
    ORDER BY [e-mail]
--
GO
--=====================================================================================================================
-- 
-- 18 =  
-- 34 =  
-- 41 =   
--
--EXECUTE ReportUser
EXECUTE ReportUserInfo 18
--EXECUTE ReportMailBox






